﻿using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Grid;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Report.Text;
using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Web;

namespace IgDocExporterRightAlignedColumn
{
	public partial class _default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			LoadGrid();
		}

		private void LoadGrid()
		{
 			List<WorkItem> reportData = new List<WorkItem>()
			{
				new WorkItem { ProjectId = "061597-1014", Name = "Adams, Christi R.", Hours = 21.9M },
				new WorkItem { ProjectId = "061597-1014", Name = "Gray, Reyna M.", Hours = 2.5M },
				new WorkItem { ProjectId = "061597-1014", Name = "Grodin, James S.", Hours = 5.4M },
				new WorkItem { ProjectId = "061597-1014", Name = "Menagh, Megan M.", Hours = 0.1M },
				new WorkItem { ProjectId = "061597-1014", Name = "Scott, Stephenie", Hours = 2.0M },
				new WorkItem { ProjectId = "061597-1011", Name = "Adams, Christi R.", Hours = 6.7M },
				new WorkItem { ProjectId = "061597-1011", Name = "Gray, Reyna M.", Hours = 0.8M },
				new WorkItem { ProjectId = "061597-1011", Name = "Grodin, James S.", Hours = 1.1M },
				new WorkItem { ProjectId = "061597-1011", Name = "Scott, Stephenie", Hours = 0.5M },
				new WorkItem { ProjectId = "061597-1010", Name = "Adams, Christi R.", Hours = 9.8M },
				new WorkItem { ProjectId = "061597-1010", Name = "Gray, Reyna M.", Hours = 0.3M },
				new WorkItem { ProjectId = "061597-1010", Name = "Grodin, James S.", Hours = 3.4M },
				new WorkItem { ProjectId = "061597-1010", Name = "Menagh, Megan M.", Hours = 0.2M},
				new WorkItem { ProjectId = "061597-1010", Name = "Scott, Stephenie", Hours = 0.8M },
				new WorkItem { ProjectId = "061597-1035", Name = "Adams, Christi R.", Hours = 10.8M },
				new WorkItem { ProjectId = "061597-1035", Name = "Gray, Reyna M.", Hours = 2.1M },
				new WorkItem { ProjectId = "061597-1035", Name = "Grodin, James S.", Hours = 1.9M },
				new WorkItem { ProjectId = "061597-1035", Name = "Menagh, Megan M.", Hours = 0.1M },
				new WorkItem { ProjectId = "061597-1035", Name = "Scott, Stephenie", Hours = 1.0M }
			};

			//enable summaries
			grid.GridView.Behaviors.SummaryRow.Enabled = true;
			//group it
			grid.GroupingSettings.GroupedColumns.Add("ProjectId");

			grid.DataSource = reportData;
			grid.DataBind();
		}

	

		private void ExportToPDF()
		{
			//report wrapper
			Infragistics.Documents.Reports.Report.Report report = new Infragistics.Documents.Reports.Report.Report();
			report.Info.Author = "Dirk Watkins";
			report.Info.Title = "Test";
			report.Info.Created = DateTime.Now;

			ISection mainReportSection = report.AddSection();
			mainReportSection.PageOrientation = PageOrientation.Landscape;
			mainReportSection.PageAlignment.Horizontal = Alignment.Center;
			mainReportSection.PageAlignment.Vertical = Alignment.Top;
			mainReportSection.PagePaddings = new Paddings(0);
			mainReportSection.PageMargins = new Margins(0);

			// Add a masthead to the report
			ISectionHeader header = mainReportSection.AddHeader();
			header.Repeat = false;
			header.Height = 100f;

			//using grid to layout the report header
			IGrid headerGrid = header.AddGrid(0, 0);
			headerGrid.Height = new RelativeHeight(100);

			//using the gridpattern to style the grid
			GridPattern gridPattern = new GridPattern();
			gridPattern.Margins = new Margins(0);
			gridPattern.Paddings = new Paddings(0);
			headerGrid.ApplyPattern(gridPattern);

			// Create a new pattern for each cell.
			GridCellPattern cellPattern = new GridCellPattern();
			cellPattern.Paddings = new Paddings(0, 0);
			cellPattern.Alignment = new ContentAlignment(Alignment.Left, Alignment.Top);

			//columns must be added for a grid element
			IGridColumn c1 = headerGrid.AddColumn();
			IGridColumn c2 = headerGrid.AddColumn();
			IGridColumn c3 = headerGrid.AddColumn();
			c1.Width = c2.Width = c3.Width = new RelativeWidth(33.33f);
			c1.Margins.All = c2.Margins.All = c3.Margins.All = 0;

			//first row of the grid in the header
			IGridRow headerGridRow = headerGrid.AddRow();

			IGridCell r1c1 = headerGridRow.AddCell();
			cellPattern.Apply(r1c1);
			r1c1.Alignment.Horizontal = Alignment.Left;
			r1c1.Alignment.Vertical = Alignment.Top;

			Infragistics.Documents.Reports.Graphics.Image img = new Infragistics.Documents.Reports.Graphics.Image(Server.MapPath("~/logo.png"));
			IContainer logoContainer = r1c1.AddContainer("LogoContainer");
			logoContainer.Alignment.Horizontal = Alignment.Left;
			IImage foleyLogo = logoContainer.AddImage(img);

			IText clientText = r1c1.AddText();
			clientText.Style.Font.Size = 9;
			clientText.Paddings.Top = 10;
			clientText.Alignment.Vertical = Alignment.Bottom;
			clientText.AddContent("Region A" + "\r\n\r\n" + "Section A-1");

			IGridCell r1c2 = headerGridRow.AddCell();
			cellPattern.Apply(r1c2);
			r1c2.Alignment.Horizontal = Alignment.Center;
			r1c2.Alignment.Vertical = Alignment.Top;
			IText sect1HeadText = r1c2.AddText();
			sect1HeadText.Alignment = TextAlignment.Center;
			sect1HeadText.AddContent("ABC Company\r\nFancy Financial Report\r\nAs of " + DateTime.Today.ToShortDateString());

			//IText viewText = r1c2.AddText();
			//viewText.Alignment = TextAlignment.Center;
			//viewText.Style.Font.Size = 9;
			//viewText.Paddings.Top = 10;
			//viewText.AddContent("9/27/2013 - 10/29/2013");

			IGridCell r1c3 = headerGridRow.AddCell();
			cellPattern.Apply(r1c3);
			r1c3.Alignment.Horizontal = Alignment.Right;
			r1c3.Alignment.Vertical = Alignment.Top;
			Infragistics.Documents.Reports.Graphics.Image imgClient = new Infragistics.Documents.Reports.Graphics.Image(Server.MapPath("~/logo2.png"));
			r1c3.AddImage(imgClient);

			string filename = "report.pdf";

			WebDocumentExporter docExporter = new WebDocumentExporter();
			docExporter.DownloadName = filename;

			//event to right align the text
			docExporter.GridRecordItemExporting += docExporter_GridRecordItemExporting;

			docExporter.DataExportMode = Infragistics.Web.UI.GridControls.DataExportMode.DataInGridOnly;		
			docExporter.Format = Infragistics.Web.UI.GridControls.FileFormat.PDF;
			docExporter.TargetPaperOrientation = Infragistics.Documents.Reports.Report.PageOrientation.Landscape;

			//this seems to control the margins for the whole report
			docExporter.Margins = new PageMargins(30, 40, 30, 30);
			docExporter.TargetPaperSize = PageSizes.Letter;

			//write the grid to the pdf report
			docExporter.Export(grid, report, mainReportSection);

			System.IO.MemoryStream stream = new System.IO.MemoryStream();
			report.Publish(stream, Infragistics.Documents.Reports.Report.FileFormat.PDF);

			//force download of the pdf
			byte[] bytes = stream.GetBuffer();

			Response.Clear();
			Response.ClearContent();
			Response.ClearHeaders();
			Response.ContentType = "application/octet-stream";
			Response.AddHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
			Response.AddHeader("Content-Length", bytes.Length.ToString());
			if (Response.IsClientConnected)
			{
				Response.OutputStream.Write(bytes, 0, bytes.Length);
				Response.Flush();
			}
			Response.Cache.SetAllowResponseInBrowserHistory(false);
			Response.Cache.SetCacheability(HttpCacheability.NoCache);
			Response.Cache.SetNoStore();
			Response.Cache.SetLastModified(DateTime.Now);
			Response.Cache.SetNoServerCaching();
			Response.ExpiresAbsolute = new DateTime(2012, 5, 24);
			HttpContext.Current.ApplicationInstance.CompleteRequest();
		}

		protected void docExporter_GridRecordItemExporting(object sender, DocumentGridRecordItemExportingEventArgs e)
		{
			//apply the text alignment from css to the report cells
			string columnCss = ((Infragistics.Web.UI.GridControls.GridField)(e.GridCell.Column)).CssClass;

			if (string.IsNullOrEmpty(columnCss))
				columnCss = e.GridCell.CssClass;

			if (columnCss.Contains("numCol"))
			{
				e.CellElement.Alignment.Horizontal = Alignment.Right;
			}

		}

		protected void btnExport_Click(object sender, EventArgs e)
		{
			ExportToPDF();
		}
	}
}